
/**************************************************************************************
**
**  The Osiris application compares one catalog of executable files
**  with another catalog of executable files. Osiris catalogs specified
**  directories of files (including MD5 hashes, modification dates,
**  and file attributes into a specified database.
**
**  Copyright (C) 2000  - the shmoo group -
**
**  This program is free software; you can redistribute it and/or
**  modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2
**  of the License, or (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
**************************************************************************************/

/**************************************************************************************
**
**    The Shmoo Group (TSG)
**
**    File:      database_handler.h
**    Author:    Brian Wotring
**
**    Date:      January 27, 2000.
**    Project:   osiris ( UNIX ).
**
**************************************************************************************/

#ifndef _DATABASE_HANDLER_H
#define _DATABASE_HANDLER_H

#include <stdlib.h>
#include <stdio.h>

#include "gdbm.h"
#include "utilities.h"

typedef struct database
{
    GDBM_FILE database_file;

    int open;
    int end;

} database;


/* public methods. */


database * open_database_for_read( const char *file_path );
database * create_database_for_write( const char *file_path );

char * get_first_key( database *db );
char * get_next_key( database *db, const char *key );

char * get_data_for_key( database *db, const char *key );
int    set_data_for_key( database *db, const char *data, const char *key );

int key_exists( database *db, const char *key );

int  at_end( database *db );
void close_database( database *db );

#endif
