
/**************************************************************************************
**
**  The Osiris application compares one catalog of executable files
**  with another catalog of executable files. Osiris catalogs specified
**  directories of files (including MD5 hashes, modification dates,
**  and file attributes into a specified database.
**
**  Copyright (C) 2000  - the shmoo group -
**
**  This program is free software; you can redistribute it and/or
**  modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2
**  of the License, or (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
**
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
**************************************************************************************/

/**************************************************************************************
**
**    The Shmoo Group (TSG)
**
**    File:      entry.h
**    Author:    Brian Wotring
**
**    Date:      January 27, 2000.
**    Project:   osiris ( UNIX ).
**
**************************************************************************************/

#ifndef _ENTRY_H
#define _ENTRY_H

#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <time.h>

#include "hash_handler.h"
#include "file_utilities.h"

typedef struct entry
{
    char *key;
    char *data;

} entry;


entry * get_entry_from_file( const char *file_path );

char * get_file_date( const char *file_path );
char * get_file_attributes( const char *file_path );
char * get_file_uid( const char *file_path );
char * get_file_gid( const char *file_path );

entry * init_entry();
void destroy_entry( entry *file_entry );

#endif
