
/**************************************************************************************
**
**  The Osiris application compares one catalog of executable files
**  with another catalog of executable files. Osiris catalogs specified
**  directories of files (including MD5 hashes, modification dates,
**  and file attributes into a specified database.
**
**  Copyright (C) 2000  - the shmoo group -
**
**  This program is free software; you can redistribute it and/or
**  modify it under the terms of the GNU General Public License
**  as published by the Free Software Foundation; either version 2
**  of the License, or (at your option) any later version.
**
**  This program is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**  GNU General Public License for more details.
** 
**  You should have received a copy of the GNU General Public License
**  along with this program; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
**************************************************************************************/

/**********************************************************************
**
**    The Shmoo Group (TSG)
**
**    File:      hash_handler.h
**    Author:    see hash_handler.c
**
**    Project:   osiris ( UNIX ).
**
**********************************************************************/


#ifndef _HASH_HANDLER_H
#define _HASH_HANDLER_H




#include "utilities.h"

/* DEC Alpha systems need LONG and U_LONG defined as int and u_int */

#ifdef __alpha
#ifndef LONG
#define LONG int
#endif 
#ifndef U_LONG
#define U_LONG u_int
#endif

/*  All other systems fall into this part. */

#else 
#ifndef LONG
#define LONG long
#endif 
#ifndef U_LONG
#define U_LONG u_long
#endif 
#endif

/* typedef a 32-bit type */

typedef unsigned LONG UINT4;

/* Data structure for MD5 (Message-Digest) computation */

typedef struct
{
    UINT4 i[2];                   /* number of _bits_ handled mod 2^64 */
    UINT4 buf[4];                 /* scratch buffer                    */
    unsigned char in[64];         /* input buffer                      */
    unsigned char digest[16];     /* actual digest after MD5Final call */

} MD5_CTX;

void MD5Init();
void MD5Update();
void MD5Final();

char *get_md5();
char *get_md5_string();


/* methods used to hash file contents. */

char * hash_file_md5( const char *file_path );

#endif;

