
#ifndef _STRING_LIST_H
#define _STRING_LIST_H


#define INITIAL_LIST_SIZE 10


#include <stdlib.h>

typedef struct list_entry
{
    char *data;
    char *name;

} list_entry;


typedef struct string_list
{
    list_entry **list;

    unsigned int size;
    unsigned int max_size;

} string_list;


string_list * new_string_list();

void double_size( string_list *list );
void dump( string_list *list );

void destroy_string_list( string_list *list );
void destroy_list_entry( list_entry *entry );

int add_item_with_name( string_list *list, const char *item, const char *name );
int append_to_item_with_name( string_list *list, const char *item, const char *name );

int item_with_name_exists( string_list *list, const char *name );


#endif
